<?php
defined('FOLDER_CALENDAR_PATH') or die('Hacking attempt!');

// +-----------------------------------------------------------------------+
// | Basic checks                                                          |
// +-----------------------------------------------------------------------+

check_status(ACCESS_ADMINISTRATOR);

$page['active_menu'] = get_active_menu('album');

check_input_parameter('cat_id', $_GET, false, PATTERN_ID);
$cat_id = $_GET['cat_id'];

$admin_album_base_url = get_root_url().'admin.php?page=album-'.$cat_id;
$self_url = FOLDER_CALENDAR_ADMIN.'-album&amp;cat_id='.$cat_id;

$query = '
SELECT *
  FROM '.CATEGORIES_TABLE.'
  WHERE id = '.$cat_id.'
;';
$category = pwg_db_fetch_assoc(pwg_query($query));

if (!isset($category['id']))
{
  die("unknown album");
}


// category must be virtual
if ($category['dir'] != NULL)
{
  die("physical album");
}
$month_list = $lang['month'];
$month_list[0]='------------';
ksort($month_list);


// +-----------------------------------------------------------------------+
// | Tabs                                                                  |
// +-----------------------------------------------------------------------+

include_once(PHPWG_ROOT_PATH.'admin/include/tabsheet.class.php');
$tabsheet = new tabsheet();
$tabsheet->set_id('album');
$tabsheet->select('CalendarFolder');
$tabsheet->assign();


// +-----------------------------------------------------------------------+
// | Save date                                                             |
// +-----------------------------------------------------------------------+


  // test if it was a Calendar Album
  $query = '
SELECT *
  FROM '.FOLDER_CALENDAR_TABLE.'
  WHERE Catid = '.$cat_id.'
;';
$calendar_query = pwg_query($query);
$calendarv = false;
 $was_calendar = pwg_db_num_rows($calendar_query);

  // Si le calendrier est présent dans la base de données
  if($was_calendar)
  {

	  $calendarv = true;
	  $calendar_result = pwg_db_fetch_assoc($calendar_query );
	  $begindate =date($calendar_result["date_begin"]);
	  $enddate =date($calendar_result["date_end"]);
	  if(isset($_POST['submitCalendar']))
	  {

			if(isset($_POST['is_calendar']))
			{
			  
					  /*Si le calendrier n'est plus présent dans la base de données */
					  if ( !$_POST['is_calendar'])
					  {
						pwg_query('DELETE FROM '.FOLDER_CALENDAR_TABLE.' WHERE Catid = '.$cat_id.';');
						$calendarv = false;
					  }
					  else
					  {
						 // Mise à jour des paramètres du dossier
						 if (isset($_POST['start_day']) and isset($_POST['start_month']) and  isset($_POST['start_year']) and isset($_POST['end_month'])  and isset($_POST['end_day'])  and isset($_POST['end_year'])   )
						{
							$begindate = ($_POST['start_year'].'-'.$_POST['start_month'].'-'.$_POST['start_day'] );
							$enddate = ($_POST['end_year'] .'-'.$_POST['end_month'].'-'.$_POST['end_day'] );
							pwg_query('Update '.FOLDER_CALENDAR_TABLE.'  SET date_begin="'.$begindate.'",date_end="' .$enddate.'" where Catid='.$cat_id.';');
						 }
						 

					  }
			}
			else
			{
				$calendarv = false;
				pwg_query('DELETE FROM '.FOLDER_CALENDAR_TABLE.' WHERE Catid = '.$cat_id.';');
				//$calendarv = false;
			}

      }

  }
  else
  {
	$calendarv = false;
	  /* Ajout du calendrier dans la base de données */
	  if (isset($_POST['is_calendar']) )
	  {
		//Ajout du calendrier';
		  if (isset($_POST['start_day']) and isset($_POST['start_month']) and  isset($_POST['start_year']) and isset($_POST['end_month'])  and isset($_POST['end_day'])  and isset($_POST['end_year'])   )
		{
			$calendarv = true;		
			$begindate = ($_POST['start_year'] .'-'.$_POST['start_month'].'-'.$_POST['start_day'] );
			$enddate = ($_POST['end_year'] .'-'.$_POST['end_month'].'-'.$_POST['end_day'] );
			pwg_query('INSERT INTO '.FOLDER_CALENDAR_TABLE.' (Catid, date_begin, date_end) values ('.$cat_id.', \''.$begindate.'\',\''.$enddate.'\') ;');

		 }
	  }
  }
  
// +-----------------------------------------------------------------------+
// | Display page                                                          |
// +-----------------------------------------------------------------------+


/* select options, for html_options */
$options = array(
  'tags' => array(
    'name' => l10n('Tags'),
    'options' => array(
      'all'   => l10n('All these tags'),
      'one'   => l10n('One of these tags'),
      'none'  => l10n('None of these tags'),
      'only'  => l10n('Only these tags'),
      ),
    ),
  'date' => array(
    'name' => l10n('Date'),
    'options' => array(
      'the_post'     => l10n('Added on'),
      'before_post'  => l10n('Added before'),
      'after_post'   => l10n('Added after'),
      'the_taken'    => l10n('Created on'),
      'before_taken' => l10n('Created before'),
      'after_taken'  => l10n('Created after'),
      ),
    ),
  'name' => array(
    'name' => l10n('Photo name'),
    'options' => array(
      'contain'     => l10n('Contains'),
      'begin'       => l10n('Begins with'),
      'end'         => l10n('Ends with'),
      'not_contain' => l10n('Doesn\'t contain'),
      'not_begin'   => l10n('Doesn\'t begin with'),
      'not_end'     => l10n('Doesn\'t end with'),
      'regex'       => l10n('Regular expression'),
      ),
    ),
  'album' => array(
    'name' => l10n('Album'),
    'options' => array(
      'all'   => l10n('All these albums'),
      'one'   => l10n('One of these albums'),
      'none'  => l10n('None of these albums'),
      'only'  => l10n('Only these albums'),
      ),
    ),
  'dimensions' => array(
    'name' => l10n('Dimensions'),
    'options' => array(
      'width'  => l10n('Width'),
      'height' => l10n('Height'),
      'ratio'  => l10n('Ratio').' ('.l10n('Width').'/'.l10n('Height').')',
      ),
    ),
  'author' => array(
    'name' => l10n('Author'),
    'options' => array(
      'is'      => l10n('Is'),
      'in'      => l10n('Is in'),
      'not_is'  => l10n('Is not'),
      'not_in'  => l10n('Is not in'),
      'regex'   => l10n('Regular expression'),
      ),
    ),
  'hit' => array(
    'name' => l10n('Hits'),
    'options' => array(
      'less' => l10n('Bellow'),
      'more' => l10n('Above'),
      ),
    ),
  'rating_score' => array(
    'name' => l10n('Rating score'),
    'options' => array(
      'less' => l10n('Bellow'),
      'more' => l10n('Above'),
      ),
    ),
  'level' => array(
    'name' => l10n('Privacy level'),
    'options' => array(),
    ),
  'limit' => array(
    'name' => l10n('Max. number of photos'),
    'options' => array(
      ''                    => '-- ' . l10n('Default') . ' --',
      'file ASC'            => l10n('File name, A &rarr; Z'),
      'file DESC'           => l10n('File name, Z &rarr; A'),
      'name ASC'            => l10n('Photo title, A &rarr; Z'),
      'name DESC'           => l10n('Photo title, Z &rarr; A'),
      'date_creation DESC'  => l10n('Date created, new &rarr; old'),
      'date_creation ASC'   => l10n('Date created, old &rarr; new'),
      'date_available DESC' => l10n('Date posted, new &rarr; old'),
      'date_available ASC'  => l10n('Date posted, old &rarr; new'),
      'rating_score DESC'   => l10n('Rating score, high &rarr; low'),
      'rating_score ASC'    => l10n('Rating score, low &rarr; high'),
      'hit DESC'            => l10n('Visits, high &rarr; low'),
      'hit ASC'             => l10n('Visits, low &rarr; high'),
      'id ASC'              => l10n('Numeric identifier, 1 &rarr; 9'),
      'id DESC'             => l10n('Numeric identifier, 9 &rarr; 1'),
      ),
    ),
  );
$template->assign('options', $options);




/* format types */
$template->assign('format_options', array(
  'portrait' => l10n('Portrait'),
  'square'   => l10n('square'),
  'lanscape' => l10n('Landscape'),
  'panorama' => l10n('Panorama'),
  ));

/* all albums */
$query = '
SELECT
    id,
    name,
    uppercats,
    global_rank
  FROM '.CATEGORIES_TABLE.'
;';
display_select_cat_wrapper($query, array(), 'all_albums');

// +-----------------------------------------------------------------------+
// |                              dimensions                               |
// +-----------------------------------------------------------------------+

$widths = array();
$heights = array();
$ratios = array();

// get all width, height and ratios
$query = '
SELECT
  DISTINCT width, height
  FROM '.IMAGES_TABLE.'
  WHERE width IS NOT NULL
    AND height IS NOT NULL
;';
$result = pwg_query($query);

while ($row = pwg_db_fetch_assoc($result))
{
  if ($row['width']>0 && $row['height']>0)
  {
    $widths[] = $row['width'];
    $heights[] = $row['height'];
    $ratios[] = floor($row['width'] / $row['height'] * 100) / 100;
  }
}

$widths = array_unique($widths);
sort($widths);

$heights = array_unique($heights);
sort($heights);

$ratios = array_unique($ratios);
sort($ratios);

$dimensions['bounds'] = array(
  'min_width' => $widths[0],
  'max_width' => $widths[count($widths)-1],
  'min_height' => $heights[0],
  'max_height' => $heights[count($heights)-1],
  'min_ratio' => $ratios[0],
  'max_ratio' => $ratios[count($ratios)-1],
  );

// find ratio categories
$ratio_categories = array(
  'portrait' => array(),
  'square' => array(),
  'landscape' => array(),
  'panorama' => array(),
  );

foreach ($ratios as $ratio)
{
  if ($ratio < 0.95)
  {
    $ratio_categories['portrait'][] = $ratio;
  }
  else if ($ratio >= 0.95 and $ratio <= 1.05)
  {
    $ratio_categories['square'][] = $ratio;
  }
  else if ($ratio > 1.05 and $ratio < 2)
  {
    $ratio_categories['landscape'][] = $ratio;
  }
  else if ($ratio >= 2)
  {
    $ratio_categories['panorama'][] = $ratio;
  }
}

foreach ($ratio_categories as $ratio_name => $ratio_values)
{
  if (count($ratio_values) > 0)
  {
    $dimensions['ratio_'.$ratio_name] = array(
      'min' => $ratio_values[0],
      'max' => array_pop($ratio_values),
      );
  }
}

$template->assign('dimensions', $dimensions);

/* get image number */

$month_list = $lang['month'];
$month_list[0]='------------';
ksort($month_list);
if( $calendarv )
{
	$template->assign('new_calendar', $calendarv);
}

if( (isset($begindate) ||  isset($enddate)) and $calendarv  )
{
	$Abegindate =getdate( strtotime($begindate));
	$Aendate =getdate( strtotime($enddate));
	
}
else
{
	$Abegindate =getdate();
	$Aendate =getdate();
}
$template->assign( 'active_calendar',$calendarv );
$template->assign(array(
  'COUNT_SCRIPT_URL' => FOLDER_CALENDAR_PATH.'include/count_images.php',
  'level_options' => get_privacy_level_options(),
  'F_ACTION' => $self_url,
  'CATEGORIES_NAV' => get_cat_display_name_cache($category['uppercats'], FOLDER_CALENDAR_ADMIN.'-album&amp;cat_id='),
  'month_list' => $month_list,
  'START_DAY_SELECTED'=> $Abegindate['mday'],
  'START_MONTH_SELECTED'=>  $Abegindate['mon'],
  'START_YEAR'=>  $Abegindate['year'], 
  'END_MONTH_SELECTED'=>  $Aendate['mon'],
 'END_DAY_SELECTED' => $Aendate['mday'],
 'END_YEAR'=> $Aendate['year'] ,
));

$template->set_filename('folder_calendar_content', realpath(FOLDER_CALENDAR_PATH . 'admin/template/album.tpl'));
