<?php
if (!defined('PHPWG_ROOT_PATH')) die('Hacking attempt!');

class CalendarFolder_maintain extends PluginMaintain
{
  private $installed = false;

  function install($plugin_version, &$errors=array())
  {
    global $conf, $prefixeTable;

    // configuration
    if (empty($conf['Folder_Calendar']))
    {
		//Valeur par defaut 
	//Sauvegarde
      $conf['Folder_Calendar'] = null;
	  
	  //Mise a jour des paramètre de configuration
      conf_update_param('Folder_Calendar', $conf['Folder_Calendar']);
    }
    else
    {
      $new_conf = is_string($conf['Folder_Calendar']) ? unserialize($conf['Folder_Calendar']) : $conf['Folder_Calendar'];
      conf_update_param('Folder_Calendar', $conf['Folder_Calendar']);
    }

    // create tables
	//Creation of the table witch will contain begin date and the end date of the calendar
    $query = '
CREATE TABLE IF NOT EXISTS `' . $prefixeTable . 'Folder_Calendar_date` (
  `id` mediumint(8) NOT NULL AUTO_INCREMENT,
  `Catid` mediumint(8) NOT NULL,
  `date_begin` date NOT NULL,
  `date_end` date NOT NULL,
  PRIMARY KEY (`id`)
) 
;';
    pwg_query($query);
    $this->installed = true;
  }

  function activate($plugin_version, &$errors=array())
  {
    if (!$this->installed)
    {
      $this->install($plugin_version, $errors);
    }
  }

  function deactivate()
  {
  }

  
  //Fonction de désintallation du plugin
  function uninstall()
  {
    global $prefixeTable, $conf;

    conf_delete_param('Folder_Calendar');
  }

  
}
